/*-
 * ~~~~~~licensing~~~~~~
 * test-producers
 * ==========
 * Copyright (C) 2020 - 2023 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.core.producer.executor.commands;

import java.util.Map;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.google.gson.JsonObject;

import ru.entaxy.platform.core.producer.api.EntaxyProducerService;
import ru.entaxy.platform.core.producer.api.ProducerResult;
import ru.entaxy.platform.core.producer.api.ProducerResult.CommandResult;
import ru.entaxy.platform.core.producer.executor.AbstractCommandExecutor;
import ru.entaxy.platform.core.producer.executor.CommandExecutor;
import ru.entaxy.platform.core.producer.executor.objectmodel.FactoredObject;
import ru.entaxy.platform.core.producer.executor.objectmodel.FactoredObjectRef;
import ru.entaxy.platform.core.producer.executor.objectmodel.ObjectModel;

@CommandExecutor(id = "analyze", inputs = {JsonObject.class}, predecessors = {})
public class Analyze extends AbstractCommandExecutor {

	private static final Logger log = LoggerFactory.getLogger(Analyze.class);
	
	public Analyze(EntaxyProducerService entaxyProducerService) {
		super(entaxyProducerService);
	}

	@Override
	protected boolean doExecute(ProducerResult currentResult, CommandResult commandResult,
			Map<String, Object> instructions) throws Exception {
		log.debug("Executing command [{}]", getId());
		
		JsonObject jo = currentResult.findResultObject(JsonObject.class);
		
		printOutput("\n\tIncoming JSON ::\n\n");
		printOutput(jo.toString());
		
		ObjectModel om = new ObjectModel();
		om.load(jo);
		om.checkRefs();
		
		printOutput("\n\tObjectModel ::\n\n");
		for (FactoredObject fo: om.objects)
			printOutput("Object :: [" + fo.getObjectId() + "/" + fo.factoryId + ":" + fo.getObjectType() + "] :: " + fo.getOutputType());
		for (FactoredObjectRef fo: om.refs)
			printOutput("Reference :: [" + fo.definedIn.getObjectId() + " -> " + fo.getTargetId() 
				+ "; isLink=" + fo.isLink() 
				+ "; isExternal=" + fo.isExternal()
				+ "]");
		
		commandResult.resultObject(om);

		printOutput("\n\tOutgoing JSON ::\n\n");
		printOutput(om.getJsonCurrent().toString());
		
		return true;
	}
	
}
